## visad
Class Irregular3DSet

    java.lang.Object
      visad.ThingImpl
          visad.DataImpl
              visad.Set
                  visad.SimpleSet
                      visad.SampledSet
                          visad.IrregularSet
                              visad.Irregular3DSet

All Implemented Interfaces:
  Cloneable, Data, SampledSetIface, Serializable, SetIface, SimpleSetIface, Thing

public class Irregular3DSet
extends IrregularSet

Irregular3DSet represents a finite set of samples of R^3.

No Irregular3DSet with ManifoldDimension = 1. Use Gridded3DSet with ManifoldDimension = 1 instead.

See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class visad.DataImpl
`DataImpl.Syncher`

Nested classes inherited from class visad.ThingImpl
`ThingImpl.RemotePair`

Field Summary
`(package private) static float` `EPS_0`
`(package private) static int[]` `ITAB`
`(package private) static int[]` `NTAB`
`(package private) static int[]` `STAB`

Fields inherited from class visad.IrregularSet
`Delan, newToOld, oldToNew`

Fields inherited from class visad.SampledSet
`Hi, Low, Samples`

Fields inherited from class visad.SimpleSet
`ManifoldDimension`

Fields inherited from class visad.Set
`DomainCoordinateSystem, DomainDimension, hashCode, hashCodeSet, Length, SetErrors, SetUnits`

Fields inherited from class visad.DataImpl
`Type`

Fields inherited from interface visad.Data

`ABS, ACOS, ACOS_DEGREES, ADD, ASIN, ASIN_DEGREES, ATAN, ATAN_DEGREES, ATAN2, ATAN2_DEGREES, CEIL, COS, COS_DEGREES, DEGREES_TO_RADIANS, DEPENDENT, DIVIDE, EXP, FLOOR, INDEPENDENT, INV_ATAN2, INV_ATAN2_DEGREES, INV_DIVIDE, INV_POW, INV_REMAINDER, INV_SUBTRACT, LOG, MAX, MIN, MULTIPLY, NEAREST_NEIGHBOR, NEGATE, NO_ERRORS, NOP, POW, RADIANS_TO_DEGREES, REMAINDER, RINT, ROUND, SIN, SIN_DEGREES, SQRT, SUBTRACT, TAN, TAN_DEGREES, WEIGHTED_AVERAGE`

Constructor Summary
`Irregular3DSet(MathType type, float[][] samples)` a 3-D irregular set with null errors, CoordinateSystem and Units are defaults from type; topology is computed by the constructor

`Irregular3DSet(MathType type, float[][] samples, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors, Delaunay delan)`
a 3-D irregular set; samples array is organized float[3][number_of_samples]; no geometric constraint on samples; if delan is non-null it defines the topology of samples (which may have manifold dimension 2 or 3), else the constructor computes a topology with manifold dimension 3; note that Gridded3DSet can be used for an irregular set with domain dimension 3 and manifold dimension 1; coordinate_system and units must be compatible with defaults for type, or may be null; errors may be null

`Irregular3DSet(MathType type, float[][] samples, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors, Delaunay delan, boolean copy)`
`Irregular3DSet(MathType type, float[][] samples, int[] new2old, int[] old2new)` construct Irregular3DSet using sort from existing Irregular1DSet
`Irregular3DSet(MathType type, float[][] samples, int[] new2old, int[] old2new, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors)` construct Irregular3DSet using sort from existing Irregular1DSet
`Irregular3DSet(MathType type, float[][] samples, int[] new2old, int[] old2new, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors, boolean copy)`

Method Summary
`Object` `cloneButType(MathType type)` Clones this set -- changing the MathType.
`float[][]` `indexToValue(int[] index)` convert an array of 1-D indices to an array of values in R^DomainDimension
`static void` `main(String[] argv)` Simple DataImpl test, invoked as 'java visad.DataImpl'.
`VisADGeometryArray` `make2DGeometry(byte[][] color_values, boolean indexed)` create a 2-D GeometryArray from this Set and color_values
`VisADGeometryArray[][]` `makeIsoLines(float[] intervals, float lowlimit, float highlimit, float base, float[] fieldValues, byte[][] color_values, boolean[] swap, boolean dash, boolean fill, ScalarMap[] smap, double scale_ratio, double label_size, float[][][] f_array)` return basic lines in array[0], fill-ins in array[1] and labels in array[2]
`VisADGeometryArray` `makeIsoSurface(float isolevel, float[] fieldValues, byte[][] color_values, boolean indexed)`
`Set` `makeSpatial(SetType type, float[][] samples)`
`(package private) static int` `poly_triangle_stripe(int[] Tri_Stripe, int nvertex, int npolygons, int[][] vertToPoly, int[][] polyToVert)`
`int[]` `valueToIndex(float[][] value)` convert an array of values in R^DomainDimension to an array of 1-D indices
`void` `valueToInterp(float[][] value, int[][] indices, float[][] weights)` for each of an array of values in R^DomainDimension, compute an array of 1-D indices and an array of weights, to be used for interpolation; indices[i] and weights[i] are null if no interpolation is possible
`int[]` `valueToTri(float[][] value)` valueToTri returns an array of containing triangles given an array of points in R^DomainDimension

Methods inherited from class visad.IrregularSet
`clone, equals, getNeighbors, longString`

Methods inherited from class visad.SampledSet
`computeRanges, computeRanges, cram_missing, cram_samples, getHi, getLow, getNeighbors, getSamples, getSamples, init_samples, init_samples, isMissing, make1DGeometry, make3DGeometry, makePointGeometry, setGeometryArray, setGeometryArray`

Methods inherited from class visad.SimpleSet
`getManifoldDimension, setAnimationSampling`

Methods inherited from class visad.Set
`__getitem__, __len__, addEqualsCache, addNotEqualsCache, adjustType, copyDoubles, copyFloats, doubleToFloat, doubleToIndex, equalUnitAndCS, floatToDouble, getCoordinateSystem, getDimension, getDimension, getDoubles, getDoubles, getLength, getNeighbors, getSetErrors, getSetUnits, getWedge, indexToDouble, longString, merge1DSets, testEqualsCache, testNotEqualsCache, unary, unitAndCSHashCode`

Methods inherited from class visad.DataImpl

`__add__, __add__, __div__, __div__, __mod__, __mod__, __mul__, __mul__, __neg__, __pow__, __pow__, __radd__, __rdiv__, __rmod__, __rmul__, __rpow__, __rsub__, __sub__, __sub__, abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, adjustSamplingError, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, computeRanges, computeRanges, computeReferenceRanges, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, getType, invertOp, local, log, log, max, max, min, min, multiply, multiply, negate, negate, notifyReferences, pow, pow, remainder, remainder, rint, rint, round, round, setParent, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, toString, unary`

Methods inherited from class visad.ThingImpl
`adaptedAddReference, adaptedRemoveReference, addReference, removeReference`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface visad.SetIface
`doubleToIndex, equalUnitAndCS, getCoordinateSystem, getDimension, getDoubles, getDoubles, getLength, getManifoldDimension, getNeighbors, getSetErrors, getSetUnits, getWedge, indexToDouble, merge1DSets`

Methods inherited from interface visad.Data

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, adjustSamplingError, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, computeRanges, computeRanges, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, getType, local, log, log, longString, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, unary, unary`

Methods inherited from interface visad.Thing
`addReference, removeReference`

Field Detail

### EPS_0

    static final float EPS_0

See Also:
  Constant Field Values

### NTAB

    static final int[] NTAB

### ITAB

    static final int[] ITAB

### STAB

    static final int[] STAB

Constructor Detail

### Irregular3DSet

    public Irregular3DSet(MathType type,
                          float[][] samples)
                   throws VisADException

  a 3-D irregular set with null errors, CoordinateSystem and Units are defaults from type; topology is computed by the constructor

### Irregular3DSet

    public Irregular3DSet(MathType type,
                          float[][] samples,
                          CoordinateSystem coord_sys,
                          Unit[] units,
                          ErrorEstimate[] errors,
                          Delaunay delan)
                   throws VisADException

  a 3-D irregular set; samples array is organized float[3][number_of_samples]; no geometric constraint on samples; if delan is non-null it defines the topology of samples (which may have manifold dimension 2 or 3), else the constructor computes a topology with manifold dimension 3; note that Gridded3DSet can be used for an irregular set with domain dimension 3 and manifold dimension 1; coordinate_system and units must be compatible with defaults for type, or may be null; errors may be null

### Irregular3DSet

    public Irregular3DSet(MathType type,
                          float[][] samples,
                          CoordinateSystem coord_sys,
                          Unit[] units,
                          ErrorEstimate[] errors,
                          Delaunay delan,
                          boolean copy)
                   throws VisADException

### Irregular3DSet

    public Irregular3DSet(MathType type,
                          float[][] samples,
                          int[] new2old,
                          int[] old2new)
                   throws VisADException

  construct Irregular3DSet using sort from existing Irregular1DSet

### Irregular3DSet

    public Irregular3DSet(MathType type,
                          float[][] samples,
                          int[] new2old,
                          int[] old2new,
                          CoordinateSystem coord_sys,
                          Unit[] units,
                          ErrorEstimate[] errors)
                   throws VisADException

  construct Irregular3DSet using sort from existing Irregular1DSet

### Irregular3DSet

    public Irregular3DSet(MathType type,
                          float[][] samples,
                          int[] new2old,
                          int[] old2new,
                          CoordinateSystem coord_sys,
                          Unit[] units,
                          ErrorEstimate[] errors,
                          boolean copy)
                   throws VisADException

Method Detail

### makeSpatial

    public Set makeSpatial(SetType type,
                           float[][] samples)
                    throws VisADException

  Specified by:
    `makeSpatial` in interface `SetIface`
  Overrides:
    `makeSpatial` in class `Set`
  Throws:
    `VisADException`

### indexToValue

    public float[][] indexToValue(int[] index)
                           throws VisADException

  convert an array of 1-D indices to an array of values in R^DomainDimension

  Specified by:
    `indexToValue` in interface `SetIface`
  Overrides:
    `indexToValue` in class `IrregularSet`
  Throws:
    `VisADException`

### valueToTri

    public int[] valueToTri(float[][] value)
                     throws VisADException

  valueToTri returns an array of containing triangles given an array of points in R^DomainDimension

  Throws:
    `VisADException`

### valueToIndex

    public int[] valueToIndex(float[][] value)
                       throws VisADException

  convert an array of values in R^DomainDimension to an array of 1-D indices

  Specified by:
    `valueToIndex` in interface `SetIface`
  Overrides:
    `valueToIndex` in class `IrregularSet`
  Throws:
    `VisADException`

### valueToInterp

    public void valueToInterp(float[][] value,
                              int[][] indices,
                              float[][] weights)
                       throws VisADException

  for each of an array of values in R^DomainDimension, compute an array of 1-D indices and an array of weights, to be used for interpolation; indices[i] and weights[i] are null if no interpolation is possible

  Specified by:
    `valueToInterp` in interface `SimpleSetIface`
  Overrides:
    `valueToInterp` in class `IrregularSet`
  Throws:
    `VisADException`

### makeIsoLines

    public VisADGeometryArray[][] makeIsoLines(float[] intervals,
                                               float lowlimit,
                                               float highlimit,
                                               float base,
                                               float[] fieldValues,
                                               byte[][] color_values,
                                               boolean[] swap,
                                               boolean dash,
                                               boolean fill,
                                               ScalarMap[] smap,
                                               double scale_ratio,
                                               double label_size,
                                               float[][][] f_array)
                                        throws VisADException

  return basic lines in array[0], fill-ins in array[1] and labels in array[2]

  Specified by:
    `makeIsoLines` in interface `SetIface`
  Overrides:
    `makeIsoLines` in class `Set`
  Throws:
    `VisADException`

### makeIsoSurface

    public VisADGeometryArray makeIsoSurface(float isolevel,
                                             float[] fieldValues,
                                             byte[][] color_values,
                                             boolean indexed)
                                      throws VisADException

  Specified by:
    `makeIsoSurface` in interface `SetIface`
  Overrides:
    `makeIsoSurface` in class `Set`
  Throws:
    `VisADException`

### poly_triangle_stripe

    static int poly_triangle_stripe(int[] Tri_Stripe,
                                    int nvertex,
                                    int npolygons,
                                    int[][] vertToPoly,
                                    int[][] polyToVert)
                             throws VisADException

  Throws:
    `VisADException`

### make2DGeometry

    public VisADGeometryArray make2DGeometry(byte[][] color_values,
                                             boolean indexed)
                                      throws VisADException

  create a 2-D GeometryArray from this Set and color_values

  Specified by:
    `make2DGeometry` in interface `SetIface`
  Overrides:
    `make2DGeometry` in class `Set`
  Throws:
    `VisADException`

### cloneButType

    public Object cloneButType(MathType type)
                        throws VisADException

  Description copied from interface: `SetIface`
  Clones this set -- changing the MathType.

  Specified by:
    `cloneButType` in interface `SetIface`
  Overrides:
    `cloneButType` in class `IrregularSet`
  Throws:
    `VisADException`

### main

    public static void main(String[] argv)
                     throws VisADException

  Description copied from class: `DataImpl`
  Simple DataImpl test, invoked as 'java visad.DataImpl'.

  Throws:
    `VisADException`